U = {
  getOverlay: function(classStack)
  {
    if(!this.is.there(classStack)) classStack = '';

    return {
      overlay: $('.overlay-bg '+classStack),
      container: $('.overlay-container '+classStack),
      content: $('.overlay-container .content '+classStack)
    };
  },
  createEvent: function(eventName)
  {
    // Create the event.
    var event = document.createEvent('Event');

    event.initEvent(eventName, true, true);

    return event;
  },
  is: {
    there: function(item)
    {
      return typeof item != 'undefined';
    },
    type: function(item, type)
    {
      return typeof item == type;
    },
    string: function(item)
    {
      return this.type(item,'string');
    },
    object: function(item)
    {
      return this.type(item, 'object');
    }
  },
  obj_size: function(obj) {
      var size = 0, key;
      for (key in obj) {
          if (obj.hasOwnProperty(key)) size++;
      }
      return size;
  }
};;var Breadcrumbs = function()
{
  var bc = this,
      current = null;

  bc.set = function(id)
  {
    var $crumb = $('[data-controller-id="'+id+'"]'),
        $crumbs = $('li[data-controller-id]').not($crumb);

    if($crumb.length){
      bc.current = $crumb;
      $crumb.addClass('current');
      $crumbs.removeClass('current');
    }
  }

  return bc;
};/**
 * Override the BOM console to log for webkit python wrapper
 * @param protocol
 * @constructor
 */
CustomConsole = function(protocol)
{
  this.protocol = typeof protocol != 'undefined' ? protocol : 'http://';
  this.logdata = "";
  this.old_console = console

  this.log = function(message)
  {
    this.logdata += 'log:' + message + "\n";
    this.old_console.log(message);
  }

  this.warn = function(message)
  {
    this.logdata += 'warn:' + message + "\n";
    this.old_console.warn(message);
  }

  this.error = function(message)
  {
    this.logdata = 'error:' + message + "\n";
    this.old_console.error(message);
  }

  this.cleanMessage = function(message)
  {
    switch(typeof message)
    {
      case 'string':
        return encodeURIComponent(message);
        break;
      case 'object':
      case 'array':
        return encodeURIComponent(JSON.stringify(message));
    }

    return '';
  }

  this.send_message = function(type,message)
  {
    var url = this.protocol+"log?type="+type+"&msg="+this.cleanMessage(message);
    this.old_console.log("sending " + url);
    window.location.assign(url);
  }

  return this;

  this.get_log_data = function()
  {
    return this.logdata;
  }
};;/**
 * Controller for Toolfarm Bridge
 **/
 
function showPage(next_id)
{
  var $current= $('section:visible'),
    $next= $('#' + next_id);
  if(page_list.indexOf(next_id) == 0){
    $('#controller-back').attr('data-ui-state', 'inactive')
      .fadeOut();
  } else if (next_id == 'complete') {
    //Hide Navigation Buttons, show close button
    $('footer button').fadeOut();
    $('[data-controller-alt="close"]').hide()
        .attr('data-ui-state','active')
        .fadeIn();
  } else {
    $('#controller-back').attr('data-ui-state', 'active')
      .fadeIn();
  }

  if ($current.length !== 0) {
    $current.fadeOut('fast', function(){

      $next.fadeIn('fast', function(){
        $next.attr('data-ui-state','active');
      });

    });
  } else {
    $next.fadeIn('fast', function(){
        $next.attr('data-ui-state','active');
      });
  }
}

function updateInstallDirectory(directory)
{
  $('#install_directory').val(directory);
}

function showInstallDirectoryPrompt(){
  sendEventNotification('show_directory_picker', {'callback': 'updateInstallDirectory'});
}

sendInstallDirectory = function()
{
  sendEventNotification('install_directory_changed', {'directory': $('#install_directory').val()});
}

var Controller = function(afterClick)
{

  /** Called on search controller action **/
  function processEvents(current_id, next_id)
  {
      if(next_id && typeof ControllerEvents != 'undefined'){
          if(typeof ControllerEvents[next_id] != 'undefined'
              && typeof ControllerEvents[next_id] == 'function')
              ControllerEvents[next_id]();
          else
              console.log('Controller Event Not Found: '+next_id);
      }else
          console.log('ControllerEvents Not Found!');
      sendEventNotification('page_will_change', {"current": current_id, "next": next_id});
  }

  function closeAppCallback()
  {
      sendEventNotification("close");
  }

  /**
   * Set Variables for the Controller
   * @type {*}
   */
  var controller = this,
      callback   = typeof afterClick == 'undefined' ? function(){} : afterClick,
      $first = $('section:first'),
      $last  = $('section:last'),
      controller_action = function($next)
      {

      }

  controller.screens = $('section[data-controller]');

  /**
   * Master Click Function for Controller
   * Continue Button
   */
  $('body').on('click', '[data-controller-nav="1"]', function(e){

    var $button = $(this),
        $current= $('section:visible'),
        next_id   = page_list[page_list.indexOf($current.attr('id')) + 1];

    e.preventDefault();
    if (e.handled === true) {
      return;
    } else {
      e.handled = true;
    }

    if($button.attr('data-controller-disabled') != 1){
      // in production, we let the app determine if the page should change or not
      if (tfb.environment.get() == tfb.environment.ENVIRONMENTS.DEV) {
        showPage(next_id);
        //Callback for breadcrumbs
        callback(next_id, 1);
      }

      //Controller Events
      processEvents($current.attr('id'), next_id);

    }else{
      window[$button.attr('data-event')]();
    }
  });

  /**
   * Master Click Function for Controller
   * Back Button
   */
  $('body').on('click', '[data-controller-nav="-1"]', function(e){

    var $button = $(this),
        $current= $('section:visible'),
        next_id   = page_list[page_list.indexOf($current.attr('id')) - 1],
        $next= $('#' + next_id);

    e.preventDefault();
    if (e.handled === true) {
      return;
    } else {
      e.handled = true;
    }

    if($button.attr('data-controller-disabled') != 1){
      // in production, we let the app determine if the page should change or not
      if (tfb.environment.get() == tfb.environment.ENVIRONMENTS.DEV) {
        showPage(next_id);
        clearControllerEventState(true);

        //Callback for breadcrumbs
        callback(next_id, -1);
      }

      //Controller Events
      processEvents($current.attr('id'), next_id);

    }else{
      window[$button.attr('data-event')]();
    }

  });

  /**
   * Enter Press on Serial Page
   * @todo Needs Debugging!
   */
  $('input[type="text"]').keypress(function(e){

    if (e.which == 13) {
      e.preventDefault();
      $('[data-controller-nav]').trigger('click');
    }
  });

  /**
   * Close App Callback
   */
  if(U.is.there(closeAppCallback))
    $('[data-controller-alt="close"]').on('click', closeAppCallback);
};EnvironmentManager = function(ENVIRONMENT)
{
  var env = this;

  env.ENVIRONMENTS  = {
    DEV: 'DEV',
    PROD: 'PROD',
    LOCAL: 'LOCAL'
  };

  //Set Environment to DEV by Default
  env.env = U.is.there(ENVIRONMENT) ? ENVIRONMENT : env.ENVIRONMENTS.DEV;

  env.set = function(val)
  {
    env.env = val;

    return env.env;
  }

  env.get = function()
  {
    return env.env;
  }

  env.getEnvironments = function()
  {
    return env.ENVIRONMENTS;
  }

  return env;
}
;var Imports = function(callback)
{
    Imp = this;
    Imp.imports = document.querySelectorAll('link[rel="import"]');
    Imp.total = Imp.imports.length;
    Imp.loaded = 0;
    Imp.isSupported = 0;
    Imp.importsLoaded = U.createEvent("importsLoaded");
    Imp.importsLoadedCallback = typeof callback == 'function' ? callback : function(){};
    Imp.temp_el = document.createElement('div');

    //bind event
    Imp.temp_el.addEventListener('importsLoaded',Imp.importsLoadedCallback(), false);

    Imp.supportsImports = function() {
      return 'import' in document.createElement('link');
    }

    Imp.process = function() {

      Imp.loaded++;

      if(Imp.loaded==Imp.total){

        for(i=0;i<=Imp.total;i++){
          var imported_data = Imp.imports[i];

          if(typeof imported_data != 'undefined'){
            // Clone the <template> in the import.
            var template = imported_data.import.querySelector('template');
            var clone = document.importNode(template.content, true);

            document.querySelector('#'+imported_data.getAttribute("data-target")).appendChild(clone);

          }
        }

        /** Custom Event Constructor not support for Safari <= 5 **/
        //Fire Custom Event for Callback
        //Imp.temp_el.dispatchEvent(Imp.importsLoaded);

        // Listen for the event.
        document.addEventListener('build', function (e) {
          Imp.importsLoadedCallback();
        }, false);

        // target can be any Element or other EventTarget.
        document.dispatchEvent(event);
      }
  };

  /**
   * shim for imports, jquery required :(
   */
  Imp.polyfill = function()
  {
      var importNodes = $('link[rel="import"]');

      importNodes.each(function(){

          var $el = $(this),
              url = $el.attr('href');


          $.ajax({
              async:false, //force sync of get response
              url: url,
              success: function(response){
                $('#'+$el.data('target')).append($(response).html());

                Imp.loaded++;

                if(Imp.loaded==Imp.total){
                  //Fire Custom Event for Callback
                  Imp.temp_el.dispatchEvent(Imp.importsLoaded);
                }
              }
          });
      });
  };

  (function(){
      if (!Imp.supportsImports()) {
          Imp.isSupported = 0;
          Imp.polyfill();

          console.warn(
              'Imports not supported in this browser!',
              'If you are in Chrome activate html5 imports in about:flags',
              'Ajax shim activated.'
          );
      }else{
          Imp.isSupported = 1;
      }
  })();
};/**
 Load Bar for Installer Status
 **/

LoadBarBuilder = function(){

  var bar = this;

  bar.start = function()
  {
    var overlay = U.getOverlay();

    overlay.content.empty()
      .append($('.loadbar-wrap').html());
    overlay.container.fadeIn();
    overlay.overlay.fadeIn();
  };

  bar.set = function(val)
  {
    if(U.is.there(val)){

      var $status = $('h4.status:first span i'),
          status_val = +$status.text(),
          $con = $('.loadbar:first'),
          $title = $('.title', $con),
          $verbiage = $('.verbiage', $con),
          $value = $('h4.status:first span i'),
          $bar = $('.bar:first');

      if(U.is.object(val)){

        U.is.there(val.title)
          $title.text(val.title);

        U.is.there(val.label)
          $verbiage.text(val.label);

        val = U.is.there(val.value) ? val.value : '';
      }

      val = val > 100 ? 100 : val;

      if(val > status_val){
        $value.text(val);
        $bar.width(val+'%');
      }
    }else
      console.warning('Set load bar width requires value!');
  };

  bar.close = function()
  {
    var overlay = U.getOverlay();

    overlay.container.fadeOut(500,function(){
      overlay.content.empty();
    });
    overlay.overlay.fadeOut();
  }

  return bar;
};/**
 * Render Engine uses jsRender jQuery Plugin
 * @constructor
 */
var RenderEngine = function()
{
  var render = this;

  render.template_prefix = 'tmp_';
  render.block_prefix = 'block_';
  render.section_count = 0;
  render.section_total = $('section').length;

  render.build = function(id, data, num)
  {
    var $con = $('#'+id);

    if ($con.length) {

        if($con.is('section')){
          render.section_count++;

          if(render.section_count == 1)
            $con.addClass('first');

          if(render.section_count == render.section_total)
            $con.addClass('last');
        }

        $con.attr('data-controller-id', id);

        var template = $.templates(render.block_prefix+id, '#'+render.template_prefix+id),
            html = template.render(data),
            $block = $('#'+render.block_prefix+id);

        if ($block.length) {
          $block.html(html);
        }
    }
  };

  render.process_pages = function(pages, callback)
  {
    var count = U.obj_size(pages);

    jQuery.each( pages, function( i ) {

      render.build(i, pages[i]);

      if(!--count)
        callback();
    });
  };
}
;Validation = function()
{
  var v = this,
      validators = {
        required: function(val){
          return val != '';
        }
      },
      message = {
        required: $('form.serial .error')
      }

  /**
   *
   * @param val string
   * @param rules array
   * @return {Object}
   */
  v.check = function(val,rules){

    var process = 1,
        errors = [];

    for(var i=0;i<=rules.length;i++){
      if(typeof validators[rules[i]] != 'undefined' && process)
        if(!validators[rules[i]](val)){
          process=0;
          errors[i]=message[rules];
        }

      if(i+1==rules.length)
        return {process:process, errors:errors};
    }
  }

  return v;
};/**
 * Events for the final page
 */
complete = function()
{
    //Close Load Bar
    if(U.is.there(tfb.loadbar))
      tfb.loadbar.close();

    //Clear All Controller Events
    clearControllerEventState(true);

    //Show Last Section
    $('section:visible').fadeOut('fast',function(){
      $('#complete').hide()
          .attr('data-ui-state','active')
          .fadeIn();
    });

    //Hide Breadcrumbs
    $('.breadcrumbs').fadeOut();

    //Hide Navigation Buttons, show close button
    $('footer button').fadeOut();
    $('[data-controller-alt="close"]').hide()
        .attr('data-ui-state','active')
        .fadeIn();
};/**
 Events for Components
 **/

setLoadBarStatus = function()
{
  //confirm user agrees
  $('[data-controller-nav="1"]','footer')
    .attr('data-event','postComponentData')
    .attr('data-controller-disabled',1);
}


startLoadbar = function()
{
  tfb.loadbar = new LoadBarBuilder();
  tfb.loadbar.start();
}

postComponentData = function()
{
    var $form   = $('form', '#components'),
        ids     = [];

    $(':input',$form).each(function(i){
      if ($(this).is(":checked")) {
        ids[i]=$(this).val();
      }
    });

    sendEventNotification('components', {"ids": ids.join('|')});
};/**
 * Events for Pre and Post Controller Actions
 * @type {Object}
 */
ControllerEvents = {
  eula: function(){
    setEulaState();
  },
  serial: function(){
    setValidationForSerial();
  },
  uninstall: function(){

    sendEventNotification('uninstall');

    startLoadbar();
  }
};setEulaState = function()
{
  //confirm user agrees
  $('[data-controller-nav="1"]','footer')
    .attr('data-event','confirmEulaScreen')
    .attr('data-controller-disabled',1);
}


/**
 * Open Overlay with Confirm Dialogue
 */
confirmEulaScreen = function()
{
  /**
   * Confirm Hidden Field required to trigger
   * Set in the pages master object
   * pages.eula.agreement.required = 1
   */
  if($('#confirmEulaScreen').length){
    var overlay = U.getOverlay();

    overlay.content.empty()
      .append($('.confirm-eula-wrap').html());
    overlay.container.fadeIn('fast');
    overlay.overlay.fadeIn('fast');

    cancelEula();
    acceptEula();
  }else{
    clearControllerEventState();
  }
}

/**
 * Close Overlay, do not remove disabled status
 */
cancelEula = function()
{
  $('body').on('click', '#eula_no',function(){
    var overlay = U.getOverlay();

    overlay.overlay.fadeOut();
    overlay.container.fadeOut();
  });
}

/**
 * Close Overlay, remove disabled status and trigger click
 */
acceptEula = function()
{
  $('body').on('click', '#eula_yes',function(){
    var overlay = U.getOverlay();

    clearControllerEventState();

    overlay.overlay.fadeOut();
    overlay.container.fadeOut();
  });
};/**
 * Remove attributes from controller button
 */
clearControllerEventState = function(doNotTrigger)
{
  $('[data-controller-nav="1"]','footer').removeAttr('data-event')
    .removeAttr('data-controller-disabled')
    .each(function(){
      if(!U.is.there(doNotTrigger)){
          $(this).trigger('click');
      }
    });
};

sendEventNotification = function(eventName, args)
{
    // DEV == browser, so there is no host to send notifications to, just bail here. 
    if (tfb.environment.get() == tfb.environment.ENVIRONMENTS.DEV) {
        console.log("event notifications not sent in dev environment.");
        console.log("event=" + eventName + ", args=" + args);
        return;
    }
 
 
    if (typeof(args)==='undefined') args = {};

    var argString = "";
    for (var key in args) {
        argString += encodeURIComponent(key) + "=" + encodeURIComponent(args[key]) + "&";
    }
    
    // chop off the last &
    argString = argString.substring(0, argString.length - 1);
    
    if (argString !== "") {
        argString = "?" + argString;
    }
    window.location.assign(app_package.protocol + eventName + argString);
};
;/**
 *
 */

confirmSerialNumFunction = function()
{
  //Send python the Serial Number
  var $input = $('#serial_number');
  sendEventNotification('text_changed', {"page": "serial", "value": $input.val()});
  if (tfb.environment.get() === 'DEV') {
    var validate = new Validation();
    var results = validate.check($input.val(),['required']);
    if(!results.process){
        serialNumberInvalid();
    }else{
        serialNumberConfirmed();
    }
  }
};

setValidationForSerial = function()
{
  //confirm user agrees
  var $textbox = $('#serial_number');
  $textbox.on('input propertychange paste', function() { confirmSerialNumFunction(); });
  $('[data-controller-nav="1"]','footer')
    .attr('data-event','confirmSerialNumFunction');
    // change this attr to be set conditionally based on a serial_required property
    if ($('#confirmSerialNum').val() === "true") {
      $('[data-controller-nav="1"]','footer').attr('data-controller-disabled',1);
    }
};

serialNumberConfirmed = function()
{
  //Remove Error Message
  $('#serial_message').removeClass('error').addClass('valid');
  $('#serial_message p:first').text(pages['serial']['valid']);
  $('[data-controller-nav="1"]','footer').attr('data-controller-disabled',0);
};

serialNumberInvalid = function()
{
    $('#serial_message').removeClass('valid').addClass('error');
    $('#serial_message p:first').text(pages['serial']['error']);
};
;var webapp = function(ENVIRONMENT)
{
    var app = this;
    app.environment = new EnvironmentManager(ENVIRONMENT);

    app.breadcrumbs = new Breadcrumbs();

    //Controller actions with callback
    app.controller = new Controller(function(id, option){
      //Highlight current breadcrumb
      app.breadcrumbs.set(id);
    });
    app.render = new RenderEngine();

    return app;
}

overrideJSConsole = function() {
    console = new CustomConsole(app_package.protocol);
}

function getParameterByName(name) {
    name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
    var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
        results = regex.exec(location.search);
    return results == null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
}

$(document).ready(function() {
    tfb = new webapp('DEV');
    if (getParameterByName("mode") != "app") {
        tfb.render.process_pages(pages, function(){
            tfb.breadcrumbs.set(page_list[0]);
            showPage(page_list[0]);
        });
    }
});
